# todos

## aftermath

* [ ] find better solution to fullscreen on secon monitor
    * alt-tabbing should not show up
    * switching workspaces should not affect it
* [ ] prepare more effects to be composed
* [ ] put midi config into processing so we dont depend on touchosc? -> works for me, so #leftasexercise?
* [ ] clean up audio analysis code
    * [ ] sliders + midi for bands
    * [ ] maybe also scaling of bands?
    * [ ] some decay object that supports something else than liner decay?
* [ ] save+reload settings for audio analysis -> makes live fixes easier
* [ ] fix REVERT_TO_PREVIOUS shader setting


## preparation

* preparation
    * [X] make sure videos are in right format
    * [X] control playback of mp4 in glslviewer? -> no, we use obs for that now
    * [X] put videos on laptop


* Makefile
    * [X] add command to extract ratio from mp4 -> is this necessary? -> no
    * [X] disable magenta error screen
    * [ ] make command to use other monitor + fullscreen

* code
    * [X] barebones shader with lygia effects
        * [X] needs a texture to apply effect -> stacking them decision
            * [ ] option1: all FX goes on raw video, then combine
                * [ ] probably easier and more modular, seperates code for FX and order
            * [ ] option2: figure out how to write to texture so pipeline is possible
    * [X] test communication via osc with processing
        * [X] processing sketch with g4p knobs that control shader values
        * [X] how does it default if no input is coming? can I adjust from glslViewer cli? -> black or last frame, doesn't matter
    * glslViewer
        * [.] passes
            * [ ] look at inspiration: https://github.com/butterw/bShaders
            * [X] brigthness pass
                * [X] POC
            * [ ] edge detection pass
            * [ ] something that slow it down, some time-based blur
            * [ ] some feedback
            * [ ] some color shift
            * [ ] noise threshold - dithering
            * [ ] ideas from shadertoy:
                * [ ] glitch: ngMir5 https://www.shadertoy.com/view/XtSGRG
                * [ ] glitch: mpeg artifacts https://www.shadertoy.com/view/Md2GDw
                * [ ] blur: fire ghosting https://www.shadertoy.com/view/XsdGWj
                * [ ] blur: motion blur https://www.shadertoy.com/view/Xs33DS
    * processing
        * [X] processing.sound not very powerful, but joshuas trick for normalization maybe possible? try that.
        * [X] minim offers logarithmic scaling -> likely much better for analysis and what I want to do
            * yes we go with that
        * [ ] make gui for sound analysis
            * [ ] beat detection output
            * [ ] fft settings from midi
                * [ ] 2 bands
                * [ ] spectrum viz?
            * [ ] 
        * [ ] pause-osc button in g4p

* bugfixes
    * [X] DEBUG: what are the weird issues with the glslViewer cli? is it an ncurses problem?
        * [X] SOLUTION: use --noncurses 😅
    * [X] FIXME: change default color on error from hot pink, this is horrible
        * [X]  howto: see constant at https://github.com/patriciogonzalezvivo/vera/blob/ed5076fcb28db4b376b2ba4e8a22d264a8661db9/include/vera/gl/shader.h#L19C1-L19C1 and fix in https://github.com/patriciogonzalezvivo/glslViewer/blob/main/src/core/sandbox.cpp#L68
        * [X] actually implement
        * [X] deploy on laptop and desktop
