
#include "lib.frag"

uniform vec2 u_resolution;

void main() {
    vec3 color = vec3(0.);
    vec2 st = gl_FragCoord.xy/u_resolution;

    float sdf = rectSDF(st, vec2(1.));
    color += stroke(sdf, .5, .125);
    color += fill(sdf, .1);

    gl_FragColor = vec4(color, 1.);
}
