
#define PI 3.1415926538

float stroke(float x, float s, float w) {
    float d = step(s,x+w*.5) - step(s,x-w*.5);
    return clamp(d, 0., 1.);
}

float circleSDF(vec2 st) {
    return length(st-.5)*2;
}

float rectSDF(vec2 st, vec2 s) {
    st = st*2.-1.;
    return max(abs(st.x/s.x), abs(st.y/s.y));
}

float fill(float x, float size) {
    return 1.-step(size, x);
}
